# Força-servidor

Este é o servidor do jogo Força.

Visite o repositório do cliente do jogo Força [clicando aqui](https://git.luca0N.com/luca0N/Forca).

Força é um clone livre e em código aberto do famoso jogo Forca, feito em HTML5 utilizando JavaScript, CSS e HTML. O código deste jogo é distribuído sob a licença [GNU General Public License versão 3](LICENSE) ou superior, e as imagens e sons são distribuídos sob a licença [Creative Commons Attribution-ShareAlike 4.0 International](https://git.luca0N.com/luca0N/Forca/LICENSE).

## Instalação

**AVISO: este guia de instalação é apenas para aqueles que desejam executar este servidor no seu próprio equipamento!** Caso você queira jogar, [clique aqui](https://www.luca0N.com/joguitos/força).

### Requisitos

Para a instalação de um servidor:

* node.js;
* Um certificado TLS\*.

\* Na maioria dos casos, um certificado TLS é necessário porque navegadores modernos irão rejeitar conexões WebSocket que não são seguras. Caso você esteja instalando no seu computador para apenas o seu uso, um certificado não é necessário.

### Instalando o servidor

[Baixe uma versão desejada](https://git.luca0N.com/luca0N/Forca-servidor/releases). Copie os conteúdos da versão baixada no seu servidor.

Copie o arquivo [config.exemplo.json](config.exemplo.json) para config.json na mesma pasta, fazendo alterações desejadas. Você pode copiar este arquivo sem alterar ele.

Para executar o servidor, execute o seguinte comando:

```sh
$ ./iniciar.sh
```

Você também pode iniciar da seguinte maneira:

```sh
$ node .
```

Para fazer com que o cliente conecte ao servidor node.js diretamente, altere o arquivo [https://git.luca0N.com/luca0N/Forca/src/branch/master/Cliente/recursos/js/força.js](Cliente/recursos/js/força.js) no seu servidor para apontar diretamente para este servidor.

É recomendado a configuração de um proxy reverso no seu servidor HTTP(S). Cheque o manual do seu servidor para ter instruções de como fazer isto, criando um proxy reverso na porta `12501` que aponta para o servidor Força.

Na maioria dos casos, você precisa fazer com que esta conexão seja segura, ou a maioria dos navegadores irão rejeitar a conexão com o seu servidor. Quando você estiver configurando seu proxy reverso, configure o seu servidor para utilizar o seu certificado digital TLS.

# Aviso de conteúdo

Este jogo pode apresentar conteúdo que seja inadequado para crianças.

## Filtro no bate-papo

Força possui um filtro no bate-papo que é habilitado por padrão. Este filtro contém palavras que podem não ser apropriadas para todas as idades, e ele pode ser desabilitado manualmente através do campo de configurações. Caso o filtro esteja sendo habilitado, o bate-papo será automaticamente esvaziado.

Palavras censuradas são substituídas com o texto `[CENSURADO]` e borrados.

**Mantenha em mente que, assim como todos os outros filtros disponíveis na internet, este filtro não é 100% eficaz e que o jogador pode ser exposto a material inadequado.**

## Filtro de palavras e temas

O mesmo filtro do bate-papo é utilizado no filtro de palavras e temas, e ele é habilitado por padrão em todas as salas. Quando habilitado, jogadores serão impedidos de escolherem palavras e temas filtrados. O líder da sala pode desabilitar este filtro *somente* quando a sala não está em jogo. Todos os jogadores da sala serão notificados sobre alterações na opção do filtro de palavras e temas.

**Assim como o filtro de bate-papo, este filtro também não é 100% eficaz.**

